#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sasl/sasl.h>
#include <glib.h>
#include <syslog.h>

static sasl_conn_t *conn;
static int	inited = 0;
static int	result;

#define MAX_LINE 8192

gchar *
rusproxy_sasl(char *username, char *password)
{

	if (!inited)
	{
		openlog ("rusproxy_sasl", LOG_PID | LOG_NDELAY, LOG_AUTH);

		if (sasl_server_init (NULL, "rusproxy") != SASL_OK)
		{
			syslog (LOG_ERR, "Failed to initialize SASL");
			return "ERR Fail to initialize SASL";
		}

		// Create a SASL server connection context
		if (sasl_server_new ("rusproxy", NULL, NULL, NULL, NULL, NULL, 0, &conn) != SASL_OK)
		{
			if (conn)
			{
				sasl_dispose (&conn);
				sasl_done ();
			}
			syslog (LOG_ERR, "sasl_server_new failed: %s", sasl_errstring (result, NULL, NULL));
			inited = 0;
			return "ERR";
		}
	}

	if (!username || !password)
	{
		syslog (LOG_WARNING, "Missing username or password");
		return "ERR";
	}

	if (sasl_checkpass (conn, username, g_utf8_strlen (username, 256), password, g_utf8_strlen (password, 256)) == SASL_OK)
	{
//		syslog (LOG_INFO, "Authentication succeeded for user '%s'", username);
		return "OK \n";
	} else
	{
		/*
		syslog (LOG_WARNING, "SASL auth failed for user '%s': %s",
			username,
			sasl_errstring (result, NULL, NULL));
		*/
		return "ERR SASL wrong password or user\n";
	}

	if (!username)
	{
		sasl_dispose (&conn);
		sasl_done ();
		closelog ();
		inited = 0;
		return "OK \n";
	}
}
